if(!com) var com = {};
if(!com.tineye) com.tineye = {};
if(!com.tineye.tinfox) com.tineye.tinfox = {};

com.tineye.tinfox = {

    TINEYE_URL: "http://www.tineye.com",
    targetURL: '',

    showImageContext: function() {
        var tinfox = com.tineye.tinfox;

        var search_entry = document.getElementById("context-tineye-search");
        var searchbg_entry = document.getElementById("context-tineye-searchbg");

        search_entry.hidden = true;
        searchbg_entry.hidden = true;

        // Check if we should show the icon
        var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        var show_icon = prefManager.getBoolPref("tineye.show_icon");

        // All done the old fashioned way... 
        if(show_icon) {
            search_entry.setAttribute("image", "chrome://tineye/content/logo_16x16.png"); 
            search_entry.className = "menuitem-iconic";
            searchbg_entry.setAttribute("image", "chrome://tineye/content/logo_16x16.png"); 
            searchbg_entry.className = "menuitem-iconic";
        } else {
            search_entry.removeAttribute("image"); 
            search_entry.className = "";
            searchbg_entry.removeAttribute("image"); 
            searchbg_entry.className = "";
        }

        if(gContextMenu.onImage) {
            tinfox.targetURL = gContextMenu.mediaURL;
            // For versions of Firefox < 3.1
            if(!tinfox.targetURL) {
                tinfox.targetURL = gContextMenu.imageURL;
            }
            search_entry.hidden = false;
        }
        else if(gContextMenu.hasBGImage && !gContextMenu.isTextSelected) {
            tinfox.targetURL = gContextMenu.bgImageURL;
            searchbg_entry.hidden = false;
        }
    },

    showImageInit: function() {
        var menu = document.getElementById("contentAreaContextMenu");
        menu.addEventListener("popupshowing", com.tineye.tinfox.showImageContext, false);
    },

    tineyeSearch: function() {
        var tinfox = com.tineye.tinfox;

        // Depending on the sort order, send proper search criteria to TinEye
        var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        var sort_order = prefManager.getCharPref("tineye.sort_order");
        var tab_visibility = prefManager.getCharPref("tineye.tab_visibility");
        var options = "";

        switch(sort_order) {
            case "best_match":
                options = "&sort=score&order=desc";
                break;
            case "most_changed":
                options = "&sort=score&order=asc";
                break;
            case "biggest_image":
                options = "&sort=size&order=desc";
                break;
            default:
                options = "";
        }

        if(!tinfox.targetURL) return;
        var location = tinfox.TINEYE_URL + '/search/?pluginver=firefox-1.0' + options + '&url=' + encodeURIComponent(tinfox.targetURL);
        var browser = document.getElementById("content");

        switch(tab_visibility) {
            case "background":
                browser.addTab(location);
                break;
            case "foreground":
                browser.selectedTab = browser.addTab(location);
                break;
            case "current":
                browser.loadURI(location);
                break;
            default:
                browser.addTab(location);
                break;
        }
        tinfox.targetURL = ''; // Reset
    }

}

window.addEventListener("load", com.tineye.tinfox.showImageInit, false);
